Index: D:/Devel/boost/boost/wave/util/cpp_iterator.hpp
===================================================================
--- D:/Devel/boost/boost/wave/util/cpp_iterator.hpp	(revision 79782)
+++ D:/Devel/boost/boost/wave/util/cpp_iterator.hpp	(revision 79783)
@@ -515,6 +515,9 @@
                 act_token.set_value("\n");
             }
 
+            if (IS_CATEGORY(id, EOLTokenType))
+                seen_newline = true;
+
         } while (ctx.get_hooks().may_skip_whitespace(ctx.derived(), act_token, skipped_newline));
     }
     catch (boost::wave::cpplexer::lexing_exception const& e) {
Index: D:/Devel/boost/libs/wave/test/testwave/testfiles/t_9_023.cpp
===================================================================
--- D:/Devel/boost/libs/wave/test/testwave/testfiles/t_9_023.cpp	(revision 0)
+++ D:/Devel/boost/libs/wave/test/testwave/testfiles/t_9_023.cpp	(revision 79783)
@@ -0,0 +1,31 @@
+/*=============================================================================
+    Boost.Wave: A Standard compliant C++ preprocessor library
+    http://www.boost.org/
+
+    Copyright (c) 2001-2012 Hartmut Kaiser. Distributed under the Boost
+    Software License, Version 1.0. (See accompanying file
+    LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
+=============================================================================*/
+
+// Verifies that preprocessing directives are properly recognized only if
+// the '#' is really the first character on a line before macro expansion.
+// See http://www.open-std.org/jtc1/sc22/wg14/docs/rr/dr_144.html.
+
+#define _C_STD_BEGIN
+
+_C_STD_BEGIN
+#ifndef _M_CEE_PURE
+_C_LIB_DECL
+#endif
+
+//R #line 18 "t_9_023.cpp"
+//R _C_LIB_DECL
+
+//H 10: t_9_023.cpp(14): #define
+//H 08: t_9_023.cpp(14): _C_STD_BEGIN=
+//H 01: t_9_023.cpp(14): _C_STD_BEGIN
+//H 02: 
+//H 03: _
+//H 10: t_9_023.cpp(17): #ifndef
+//H 11: t_9_023.cpp(17): #ifndef _M_CEE_PURE: 0
+//H 10: t_9_023.cpp(19): #endif

Index: D:/Devel/boost/libs/wave/test/testwave/testfiles/test.cfg
===================================================================
--- D:/Devel/boost/libs/wave/test/testwave/testfiles/test.cfg	(revision 79782)
+++ D:/Devel/boost/libs/wave/test/testwave/testfiles/test.cfg	(revision 79783)
@@ -238,3 +238,4 @@
 t_9_020.cpp
 t_9_021.cpp
 t_9_022.cpp
+t_9_023.cpp
